<template>
  <BaseDataLoader v-if="loading" />
  <v-container v-else>
    <v-row>
      <v-col cols="12">
        <BaseMovieListContainer :movies="movies" />
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col cols="8">
        <v-container class="max-width">
          <v-pagination
            v-model="page"
            class="my-4"
            :length="pages"
            :total-visible="10"
          ></v-pagination>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import movieApi from '@/services/MovieApi';
import BaseMovieListContainer from '@/components/containers/MovieListContainer';
import BaseDataLoader from '@/components/presentation/BaseDataLoader';
import { mapState } from 'vuex';

export default {
  name: 'SearchMovieContainer',
  props: {
    name: {
      type: String,
      required: true
    }
  },
  data() {
    return {
      movies: [],
      page: 1,
      pages: 0,
      loading: true
    };
  },
  components: {
    BaseMovieListContainer,
    BaseDataLoader
  },
  computed: {
    ...mapState('movies', {
      favoriteMovies: 'favorites'
    })
  },
  methods: {
    fetchResult(name, page) {
      movieApi
        .fetchMovieCollection(name, page)
        .then(data => {
          if (data) {
            let movies = data.Search;
            const favoriteMovies = this.favoriteMovies;

            movies.forEach(m => {
              m.isFavorite = favoriteMovies.some(x => x.imdbID === m.imdbID);
            });

            this.movies = movies;
            this.pages = Math.floor(data.totalResults / 10) + 1;
          }

          this.loading = false;
        })
        .catch(error => {
          alert(error); // console.log(error)
        });
    }
  },
  mounted() {
    this.fetchResult(this.name, 1);
  },
  watch: {
    name(value) {
      this.fetchResult(value, 1);
    },
    page(value) {
      this.fetchResult(this.name, value);
    }
  }
};
</script>
